Ext.BLANK_IMAGE_URL = '';
Ext.ns('Example');
Example.version = '1.0';

Example.Grid = Ext.extend(Ext.grid.GridPanel, {

	 initComponent:function() {

	 	// Create RowActions Plugin
	 	this.action = new Ext.ux.grid.RowActions({
			 header:'Actions'
			,autoWidth:true
			,keepSelection:true
			,actions:[{
				 iconIndex:'action1'
				,qtipIndex:'qtip1'
				,iconCls:'icon-open'
				,tooltip:'Open'
			},{
				 iconCls:'icon-wrench'
				,tooltip:'Configure'
				,qtipIndex:'qtip2'
				,iconIndex:'action2'
				,hideIndex:'hide2'
			},{
				 iconIndex:'action3'
				,qtipIndex:'qtip3'
				,iconCls:'icon-user'
				,tooltip:'User'
				,style:'background-color:yellow'
			}]
			,groupActions:[{
				 iconCls:'icon-del-table'
				,qtip:'Remove Table'
			},{
				 iconCls:'icon-add-table'
				,qtip:'Add Table - with callback'
				,callback:function(grid, records, action, groupId) {
					Ext.ux.Message.msg('Callback: icon-add-table'
					    , 'Group: <b>{0}</b>, action: <b>{1}</b>, records: <b>{2}</b>'
					    , groupId
					    , action
					    , records.length);
				}
			},{
				 iconCls:'icon-graph'
				,qtip:'View Graph'
				,align:'left'
			}]
			,callbacks:{
				'icon-plus':function(grid, record, action, row, col) {
					Ext.ux.Message.msg('Callback: icon-plus'
					    , 'You have clicked row: <b>{0}</b>, action: <b>{0}</b>'
					    , row
					    , action);
				}
			}
		});

		this.action.on({
			action:function(grid, record, action, row, col) {
				Ext.ux.Message.msg('Event: action', '클릭한 Row: <b>{0}</b>, 액션: <b>{1}</b>'
				    , row
				    , action);
			}
			,beforeaction:function() {
				Ext.ux.Message.msg('Event: beforeaction', '핸들러에서 false반환시 액션취소.');
			}
			,beforegroupaction:function() {
				Ext.ux.Message.msg('Event: beforegroupaction', '핸들러에서 false반환시 액션취소');
			}
			,groupaction:function(grid, records, action, groupId) {
				Ext.ux.Message.msg('Event: groupaction', 'Group: <b>{0}</b>, action: <b>{1}</b>, records: <b>{2}</b>', groupId, action, records.length);
			}
		});

		Ext.apply(this, {
			 store:new Ext.data.Store({
				reader:new Ext.data.JsonReader({
					 id:'company'
					,totalProperty:'totalCount'
					,root:'rows'
					,fields:[
						{name: 'company'}
					   ,{name: 'lastChange', type: 'date', dateFormat: 'n/j h:ia'}
					   ,{name: 'industry'}
					   ,{name: 'desc'}
					   ,{name: 'action1', type: 'string'}
					   ,{name: 'action2', type: 'string'}
					   ,{name: 'action3', type: 'string'}
					   ,{name: 'qtip1', type: 'string'}
					   ,{name: 'qtip2', type: 'string'}
					   ,{name: 'qtip3', type: 'string'}
					   ,{name: 'hide2', type: 'boolean'}
					]
				})
				,proxy:new Ext.data.HttpProxy({url:'jsonData.json'})
				,sortInfo:{field:'company', direction:'ASC'}
				,listeners:{
					load:{scope:this, fn:function() {
						this.getSelectionModel().selectFirstRow();
					}}
				}
			})
			,columns:[
				{id:'company',header: "Company", width: 40, sortable: true, dataIndex: 'company'}
				,{header: "Industry", width: 20, sortable: true, dataIndex: 'industry'}
				,{header: "Last Updated", width: 20, sortable: true, renderer: Ext.util.Format.dateRenderer('m/d/Y'), dataIndex: 'lastChange'}
				,this.action
			]
			,plugins:[this.action]
			,loadMask:true
			,viewConfig:{forceFit:true}
		});

		this.bbar = new Ext.PagingToolbar({
			 store:this.store
			,displayInfo:true
			,pageSize:10
		});

		Example.Grid.superclass.initComponent.apply(this, arguments);
	}


	,onRender:function() {
		Example.Grid.superclass.onRender.apply(this, arguments);
		this.store.load({params:{start:0, limit:10}});
	}
});

//컴포넌트 등록
Ext.reg('techbuggrid', Example.Grid);















Ext.onReady(function() {
    Ext.QuickTips.init();

    var win = new Ext.Window({
         width:600
		,minWidth:320
        ,id:'agwin'
        ,height:400
        ,layout:'fit'
        ,border:false
		,plain:true
        ,closable:false
        ,title:"그리드 Row Action 처리하기"
		,items:{xtype:'techbuggrid',id:'actiongrid'}
    });
    win.show();
});